;**********************************************************************
;				CANDLE.ASM
;**********************************************************************

;DATE: JANUARY 12, 2009
;VERSION: A
;XTAL TYPE:  Internal 4 MHZ
;WRITTEN BY: RON NEWTON
;GENERAL REGISTER STARTS @ 07H
;INTERRUPT VECTOR =  NONE
;END OF PROGRAM MEMORY = 03FFH
;COMMENTS:  
;WHEN LASER HITS PHOTODIODE LED LIGHTS
;WHEN HIT AGAIN LED IS EXTINGUISHED
;
;
;**********************************************************
    
    list        p=12f508       	; list directive to define processor
	RADIX		DEC					;YOU CAN CHANGE THIS TO DEC OR OCT DEFAULT IS HEX
    #include    <p12f508.inc>   	; processor specific variable definitions
    
	   __CONFIG  _MCLRE_OFF & _CP_OFF  & _WDT_OFF   & _IntRC_OSC  

; PORT DESCRIPTIONS
;
;

#DEFINE 	NAME		PORT			;PUT IN PORT AND NUMBER HERE E.G., PORTA,0 (NOTE COMMA)
#DEFINE		PHOTO		GPIO,0			;PHOTO = GPIO,0 INPUT
#DEFINE		LED			GPIO,2			;LED = GPIO,2 OUTPUT


;NEW REGISTERS
RANDOM		EQU		07H					;RANDOM REGISTER
TEMP		EQU		08H					;TEMP REGISTER
TEMP1		EQU		09H					;TEMP 1 REGISTER
COUNT		EQU		0AH					;COUNT REGISTER
COUNT1		EQU		0BH					;COUNT 1 REGISTER	
COUNT2		EQU		0BH					;COUNT 2 REGISTER


	ORG		0H							;START OF PROGRAM OR RESET
START	MOVLW		B'00000001'			;PROGRAM GPIO FOR ALL OUTPUTS
		TRIS		GPIO				;LOAD TRIS
		MOVLW		0					;CLEAR OPTION
		OPTION							;LOAD OPTION
		MOVLW		3					;LOADING 3
		MOVWF		RANDOM				;SETTING RANDOM SEED LOADING

S1		BTFSC		PHOTO				;WAIT FOR LASER
		GOTO		$-1					;JUMP BACK ONE UNTIL LOW
		DECFSZ		COUNT,1				;DELAY FOR ANTIBOUNCE
		GOTO		$-1					;JUMP BACK ONE UNTIL HIGH
		DECFSZ		COUNT1,1			;DECREASE COUNT1
		GOTO		$-3					;JUMP BACK 3 UNTIL ZERO

S2		CALL		LFSR				;TURN ON LED
		MOVF		RANDOM,0			;KEEPING RANDOM NUMBER FOR NEXT LFSR
		MOVWF		TEMP				;TRANSFERING RANDOM NUMBER TO TEMP
		MOVWF		TEMP1				;TRANSFERING RANDOM NUMBER TO TEMP1
		COMF		TEMP1,1				;TAKE COMPLEMENT OF TEMP1
		BCF			LED					;TURN ON LED FOR TEMP TIME
		BTFSS		PHOTO				;CHECK FOR IR TRANSMISSION
		GOTO		S3					;IF DETECTED JUMP TO S3
		DECFSZ		TEMP,1				;DECREASE TEMP
		GOTO		$-3					;JUMP BACK 3 UNTIL ZERO
		BSF			LED					;TURN OFF LED FOR TEMP1 TIME
		DECFSZ		TEMP1,1				;DECREASE TEMP1
		GOTO		$-1					;JUMP BACK ONE UNTIL ZERO
		BTFSS		PHOTO				;CHECKING FOR IR
		GOTO		S3					;IR DETECTED GOTO S3
		GOTO		S2					;NOT DETECTED GO TO S2
S3		BSF			LED					;TURN OFF LED
		DECFSZ		COUNT,1				;DELAY FOR ANTIBOUNCE
		GOTO		$-1					;NOT ZERO JUMP BACK ONE
		DECFSZ		COUNT1,1			;MORE DELAY FOR ANTIBOUNCE
		GOTO		$-3					;NOT ZERO JUMP BACK THREE
		GOTO		START				;GO TO START


LFSR	   	RLF     RANDOM,W			;RANDOM NUMBER GENERATOR
            RLF     RANDOM,W			;CAUSE LED TO FLICKER LIKE CANDLE
            BTFSC   RANDOM,4			;CHECK RANDOM 4 IS CLEAR
            XORLW   1					;NOT CLEAR XORLW 1
            BTFSC   RANDOM,5			;CHECK RANDOM 5 IS CLEAR
            XORLW   1					;NOT CLEAR XORLW 1
            BTFSC   RANDOM,3			;CHECK RANDOM 3 IS CLEAR
            XORLW   1					;NOT CLEAR XORLW 1
            MOVWF   RANDOM				;MOVE XORLW INTO RANDOM
            RETLW   0					;RETURN

    END                       		; directive 'end of program'