;**********************************************************************
;   This file is a basic code template for assembly code generation   *
;   on the PIC12F508. This file contains the basic code               *
;   building blocks to build upon.                                    *
;                                                                     *
;   Refer to the MPASM User's Guide for additional information on     *
;   features of the assembler (Document DS33014).                     *
;                                                                     *
;   Refer to the respective PIC data sheet for additional             *
;   information on the instruction set.                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Filename:	    Wand.asm                                 *
;    Date:          JULY 30, 2010                                      *
;    File Version:  A                                                 *
;                                                                     *
;    Author:        RONALD NEWTON                                     *
;    Company:                                                         *
;                                                                     * 
;                                                                     *
;**********************************************************************
;                                                                     *
;    Files Required: P12F508.INC                                      *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:                                                           *
;                                                                     *
;**********************************************************************

	list      p=12F508            ; list directive to define processor
	#include <p12F508.inc>        ; processor specific variable definitions

	__CONFIG   _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file. 
; See respective data sheet for additional information on configuration word.


;***** VARIABLE DEFINITIONS

COUNT	EQU		07H				;TIMING REGISTER
COUNT1	EQU		08H				;TIMING REGISTER

;**********************************************************************
	ORG     0x1FF             ; processor reset vector

; Internal RC calibration value is placed at location 0x1FF by Microchip
; as a movlw k, where the k is a literal value.

	ORG     0x000             ; coding begins here
	movwf   OSCCAL            ; update register with factory cal value 

AWAYWEGO
		CLRF		GPIO			;PRE-CLEARING OF GPIO
		MOVLW		B'00001000'		;MAKE ALL OUTPUTS (GPIO 3 CAN ONLY BE INPUT)
		MOVWF		GPIO			;LOAD
		TRIS		GPIO			;LOAD
		MOVLW		.10				;LOAD COUNT 1 WITH DECIMAL 10
		MOVWF		COUNT1			;LOAD
	
;**************************TESTING AREA**************************
TEST

;**************************FIRING IR ******************



START	MOVLW	B'00000000'			;TURN ON LED
		MOVWF	GPIO				;LOAD
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		MOVLW	B'11111111'			;TURN OFF LED
		MOVWF	GPIO				;LOAD
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		NOP							;TIMING FOR 36 KHZ
		DECFSZ	COUNT,1				;PERFORM FOR 69 MILLI-SECONDS
		GOTO	START				;PERFORM FOR 69 MILLI-SECONDS
		DECFSZ	COUNT1,1			;PERFORM FOR 69 MILLI-SECONDS
		GOTO	START				;PERFORM FOR 69 MILLI-SECONDS
		GOTO	$					;WAIT UNTIL POWERED OFF.


	END                       ; directive 'end of program'

